// Copyright (c) 2008,2009 by Andrey Mirtchovski <mirtchovski@gmail.com>

/* Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * ANDREY MIRTCHOVSKI AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */


var photos;						// Array containing photos found in feed
var maxImages = 10;				// how many do we want displayed
var finishedLoading;			// Flag for whether images are loaded
var loadingAnimationTimer;		// Timer for "Loading..." animation
var controls;					// User interface controls (Controls.js)
var caption;					// Caption controller (Controls.js)
var infobutton;                 // Info Button

var slideshow;					// Slideshow controller (Slideshow.js)
var willReload = 0;				// Don't restart the slideshow after we show front
var buildVersion = null;
var availVersion = null;
var firstLoad = 1;
var isBack = 0;

//
// Function: loadPhotosFromFeed(url)
// Starts loading the PhotoCast feed
// parseResponse() will be called when it finishes loading.
//
// url: URL of the PhotoCast feed
//
function getDOMfromXML(xml) {
	var d = document.createElement('div');
	xml = xml.substring(xml.indexOf('<body') + xml.substring(xml.indexOf('<body')).indexOf('>')+1);
	xml = xml.substring(0, xml.indexOf('</body>'));
	d.innerHTML = xml;
	
	return d;
}

var mainurl = "http://www.weather.gc.ca";
var radarimg = "/data/radar/";

function loadPhotosFromFeed(url)
{
	var er;
	photos.length = 0;

	SimpleAJAXCall(
		url,
        function(xml) {
			var i = 1, htmlend;
			var mphotos = new Array();
            for(k = 0; k < slideshow.current.view.overlays.length; k++) {
                slideshow.current.view.overlays[i].src = "";
                slideshow.prev.view.overlays[i].src = "";
                slideshow.next.view.overlays[i].src = "";
            }
            var obj = document.getElementById("satellites");
            var i = obj.selectedIndex
            if(obj && obj.options[i].text.indexOf('Surface Analysis (Preliminary)') >= 0) {
                mphotos.push({ title: '', url: mainurl + '/data/analysis/jac00_50.gif' });
                mphotos.push({ title: '', url: mainurl + '/data/analysis/jac06_50.gif' });
                mphotos.push({ title: '', url: mainurl + '/data/analysis/jac12_50.gif' });
                mphotos.push({ title: '', url: mainurl + '/data/analysis/jac18_50.gif' });
            } else if(obj && obj.options[i].text.indexOf('Surface Analysis (Complete)') >= 0) {
                mphotos.push({ title: '', url: mainurl + '/data/analysis/947_50.gif' });
                mphotos.push({ title: '', url: mainurl + '/data/analysis/951_50.gif' });
                mphotos.push({ title: '', url: mainurl + '/data/analysis/935_50.gif' });
                mphotos.push({ title: '', url: mainurl + '/data/analysis/941_50.gif' });
            } else if(obj && obj.options[i].text.indexOf('Upper Air Analysis') >= 0) {
                mphotos.push({ title: '', url: mainurl + '/data/analysis/sah_50.gif' });
                mphotos.push({ title: '', url: mainurl + '/data/analysis/sai_50.gif' });
                mphotos.push({ title: '', url: mainurl + '/data/analysis/saj_50.gif' });
                //mphotos.push({ title: '', url: mainurl + '/data/analysis/saa_50.gif' });
            } else if((htmlstart = xml.indexOf("wxo-animator")) > 0) {
				htmlend = xml.length;
				var wc = xml.slice(htmlstart, htmlend);
			
				while(wc.indexOf("data-wxo-anim-") >= 0) {
					var begin = wc.indexOf("/data/satellite");
					var end = wc.indexOf('jpg\"');
					var str = mainurl + wc.substr(begin, end-begin+3);
					mphotos.push({ title: '', url: str });
					wc = wc.slice(end+3, wc.length);
				}
			} else {
				// it's a radar image
				var endDate = null;      // date of newest image from EC website 
				var nextHour = 0;        // used for calculating the next hour
				var nextMinute = 0;      // used for calculating the next minute
				var nextDate = null;     // date of the current image to fetch
                
                var x2 = getDOMfromXML(xml);
								
				var image = x2.getElementsByClassName("wxo-radar-img");
				if(image.length <= 0) {
					alert("No images found in HTML");
				} else {
					var wc = image[0].src;
                    var url = mainurl + "/" + wc.substring(8, wc.length);
                    mphotos.push({ title: '', url: url });
                    
                    var imgurl = url.substr(0, url.lastIndexOf("/"));
            
                    var nxml = xml.substr(xml.indexOf("<p>Long (3hr):"), xml.length);
                    while(nxml.indexOf("display='") >= 0) {
                        nxml = nxml.substr(nxml.indexOf("display='"), nxml.length);
                        mphotos.push({title: '', url: imgurl + "/" + nxml.substring(9, nxml.indexOf('&amp')-1) + ".GIF" });
                        nxml = nxml.substr(9, nxml.length);
                    }
				}
                mphotos.reverse();

        	}
			// Preload images
			if (mphotos.length > 0) {                
				var offset;
				if(maxImages >= mphotos.length)
					offset = 0;
				else
					offset = mphotos.length - maxImages;
					
				for (var i = offset; i < mphotos.length; i++) {
                    var image = new Image();
					mphotos[i].image = image;
					image.src = mphotos[i].url.replace("radar/detailed/temp_image", "radar/temp_image");
					photos[i-offset] = mphotos[i];
				}
				startLoadingUpdate();
                loadOverlays();
			} else {
				stopLoadingAnimation();
				setLoadingText(getLocalizedString("No images were found."));
			}
		},
		'GET',
        null
	);
}

function loadOverlays() {
    if(photos.length == 0) {
        return;
    }
                // overlays, if needed
                var str = photos[0].url;
                for(i = 0; i < slideshow.prev.view.overlays.length; i++) {
                        slideshow.current.view.setOverlay("", i);
                        slideshow.prev.view.setOverlay("", i);
                        slideshow.next.view.setOverlay("", i);
                }
                if(str.indexOf("COMPOSITE_NAT") > 0) {
                    // national composite
                    slideshow.current.view.setOverlay(mainurl+"/cacheable/images/radar/layers/composite_cities/nat_composite.gif", 0);
                    slideshow.prev.view.setOverlay(mainurl+"/cacheable/images/radar/layers/composite_cities/nat_composite.gif", 0);
                    slideshow.next.view.setOverlay(mainurl+"/cacheable/images/radar/layers/composite_cities/nat_composite.gif", 0);
                } else if(str.indexOf("COMPOSITE_") > 0) {
                    var thr = str.substr(str.indexOf("COMPOSITE_")+10,  3).toLowerCase();
                    if(thr === "pac") thr = "pyr"; // damn! some data hiding is happening here!
                    if(thr === "wrn") thr = "pnr"; // damn! some data hiding is happening here!
                    if(thr === "ern") thr = "atl"; // damn! some data hiding is happening here!
                    slideshow.current.view.setOverlay(mainurl+"/cacheable/images/radar/layers/composite_cities/"+thr+"_composite.gif", 0);
                    slideshow.prev.view.setOverlay(mainurl+"/cacheable/images/radar/layers/composite_cities/"+thr+"_composite.gif", 0);
                    slideshow.next.view.setOverlay(mainurl+"/cacheable/images/radar/layers/composite_cities/"+thr+"_composite.gif", 0);
                } else if(str.indexOf("temp_image") > 0) {
                    //overlays=/cacheable/images/radar/layers/rivers/xsm_rivers.gif
                    //overlays=/cacheable/images/radar/layers/roads/XSM_roads.gif
                    //overlays=/cacheable/images/radar/layers/radar_circle/radar_circle.gif
                    //overlays=/cacheable/images/radar/layers/additional_cities/xsm_towns.gif
                    //overlays=/cacheable/images/radar/layers/default_cities/xsm_towns.gif
                    
					// EC changed station names from 3-letter to any number of letters. Assume < 30
                    var thrHi = str.substr(str.indexOf("temp_image/")+11, 30);
                    if(thrHi[0] == '/') {
                        thrHi = str.substr(str.indexOf("temp_image/")+12, 30);
                    }
					thrHi = thrHi.substr(0, thrHi.indexOf("/"));
                    var thrLo = thrHi.toLowerCase();
                    var cts = document.getElementById("cities");
                    var mcts = document.getElementById("more_cities");
                    var rds = document.getElementById("roads");
                    var rdns = document.getElementById("road_numbers");
                    var rvs = document.getElementById("rivers");
                    var rcs = document.getElementById("radar_circles");
                    if(rvs.children[0].checked) {
                        slideshow.current.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/rivers/"+thrLo+"_rivers.gif", 0);
                        slideshow.prev.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/rivers/"+thrLo+"_rivers.gif", 0);
                        slideshow.next.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/rivers/"+thrLo+"_rivers.gif", 0);
                        alert(mainurl+"/cacheable/images/radar/layers_detailed/rivers/"+thrLo+"_rivers.gif");
                    }
                    if(rds.children[0].checked) {
                        slideshow.current.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/roads/"+thrHi+"_roads.gif", 1);
                        slideshow.prev.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/roads/"+thrHi+"_roads.gif", 1);
                        slideshow.next.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/roads/"+thrHi+"_roads.gif", 1);
                    }
                    if(rcs.children[0].checked) {
                        slideshow.current.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/radar_circle/radar_circle.gif", 2);
                        slideshow.prev.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/radar_circle/radar_circle.gif", 2);
                        slideshow.next.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/radar_circle/radar_circle.gif", 2);
                    }
                    if(mcts.children[0].checked) {
                        slideshow.current.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/additional_cities/"+thrLo+"_towns.gif", 3);
                        slideshow.prev.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/additional_cities/"+thrLo+"_towns.gif", 3);
                        slideshow.next.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/additional_cities/"+thrLo+"_towns.gif", 3);
                        alert(mainurl+"/cacheable/images/radar/layers_detailed/additional_cities/"+thrLo+"_towns.gif");
                    }
                    if(cts.children[0].checked) {
                        slideshow.current.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/default_cities/"+thrLo+"_towns.gif", 4);
                        slideshow.prev.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/default_cities/"+thrLo+"_towns.gif", 4);
                        slideshow.next.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/default_cities/"+thrLo+"_towns.gif", 4);
                    }
                    if(rdns.children[0].checked) {
                        slideshow.current.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/road_labels/"+thrLo+"_labs.gif", 5);
                        slideshow.prev.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/road_labels/"+thrLo+"_labs.gif", 5);
                        slideshow.next.view.setOverlay(mainurl+"/cacheable/images/radar/layers_detailed/road_labels/"+thrLo+"_labs.gif", 5);
                    }
    }
}

function setSize()
{
	var obj = document.getElementById("scale");
	var scale = parseFloat(obj.options[obj.selectedIndex].value);
	
	if(scale == 0) {
		scale = 2;
	}
	
	var image = photos[0].image;
	if(image != null && image.complete) {
		if(!isBack)
			window.resizeTo(image.width*scale, image.height*scale);
	} else {
		alert("setSize: image not loaded.");
	}
}

//
// Function: startLoadingUpdate()
// Starts the background process that monitors whether images are loaded
//
function startLoadingUpdate()
{
    updateLoaded();
}

//
// Function: updateLoaded()
// Checks whether images have completed loading.  If so, stops the progress
// indicator and starts the slideshow.
//
function updateLoaded()
{
    var total = photos.length;
    var loaded = 0;
    for (var i = 0; i < total; i++) {
        var image = photos[i].image;
        if (image != null && image.complete) {
			// resize only once
			loaded++;
        }
    }
	
    if (loaded < total) {
        setTimeout(updateLoaded, 250);
		var ld = document.getElementById("loading-total");
		ld.innerText = loaded+"/"+total;
	} else {
		var ld = document.getElementById("loading-total");
		ld.innerText = '';
		
        hideLoadingMessage();
        finishedLoading = true;
		willReload = 0;
        setTimeout(startSlideShow, 250);
		setTimeout(setSize, 0);
    }
}

//
// Function: photoChanged(number)
// Called by the slideshow whenever the photo changes so we can update
// the caption.
//
function photoChanged(number)
{
    setCaption("[" + (number + 1) + "/" + photos.length + "]");
}

//
// Function: startSlideShow()
// Enables the slideshow and starts it playing.
//
function startSlideShow()
{
    if (controls) {
        controls.setEnabled(true);
        controls.setPaused(false);
    }
    showInterfaceElements();
    slideshow.start();
}

//
// Function: setLoadingText(message)
// Displays a message in the "Loading" area.
// Used by the loading animation and error messages.
//
// message: text to display
//
function setLoadingText(message)
{
    var loadingElt = document.getElementById("loading");
    if (loadingElt) {
        loadingElt.innerText = message;
    }
}

//
// Function: startLoadingAnimation()
// Starts the "Loading..." animation's timer
//
function startLoadingAnimation()
{
    var dots = 0;
    var animateLoadingDots = function ()
    {
        var loading = getLocalizedString("Loading");
        for (var i = 0; i < dots; i++) {
            loading = loading + ".";
        }
        setLoadingText(loading);

        if (++dots > 3) {
            dots = 0;
        }
    };

    loadingAnimationTimer = setInterval(animateLoadingDots, 500);
}

//
// Function: stopLoadingAnimation()
// Stops the "Loading..." animation's timer
//
function stopLoadingAnimation()
{
    if (loadingAnimationTimer != null) {
        clearInterval(loadingAnimationTimer);
        loadingAnimationTimer = null;
    }
}

//
// Function: setCaption(captionText)
// Displays a caption in the caption area
//
// captionText: text of the caption to display
//
function setCaption(captionText)
{
    caption.setCaption(captionText);
}

//
// Function: hideElement(elementId)
// Turn off display for the given element.
//
// elementId: DOM id of the element to hide.
//
function hideElement(elementId)
{
    var element = document.getElementById(elementId);
    if (element) {
        element.style.display = "none";
    }
}

//
// Function: showElement(elementId)
// Turn on display for the given element.
//
// elementId: DOM id of the element to show.
//
function showElement(elementId)
{
    var element = document.getElementById(elementId);
    if (element) {
        element.style.display = "block";
    }
}

//
// Function hideInterfaceElements()
// Hides the user interface controls while the photos are loading
//
function hideInterfaceElements()
{
    controls.hide();
    caption.hide();
}

//
// Function: showInterfaceElements()
// Enables the user interface controls once the slideshow is ready
//
function showInterfaceElements()
{
    controls.show();
    if (attributes.showTitle != 2) {
        caption.show();
    }
}

//
// Function: showLoadingMessage()
// Turns on the "Loading..." message and starts it animating
//
function showLoadingMessage()
{
    showElement("loading");
    startLoadingAnimation();
}

//
// Function: hideLoadingMessage()
// Stops the "Loading..." message's animation and hides it
//
function hideLoadingMessage()
{
    stopLoadingAnimation();
    hideElement("loading");
}

//
// Function: populateDisplayTimeList(displayTimeValues)
// Fills the popup list on the back of the widget with the available
// slide durations
//
// displayTimeValues: list of durations available
//
function populateDisplayTimeList(displayTimeValues)
{
    var popup = document.getElementById("display-time");
    if (popup != null) {
        while (popup.length) {
            popup.remove(0);
        }

        for (var i = 0; i < displayTimeValues.length; i++) {
            var option = document.createElement("option");
            option.value = displayTimeValues[i].value;
            option.innerText = getLocalizedString(displayTimeValues[i].text);
            popup.add(option);
        }
    }
}

//
// Function: setDisplayTime(time)
// Set the current slide duration
//
// time: slide duration in seconds
//
function setDisplayTime(time)
{
    if (time) {
        slideshow.photoDuration = time;
    }
    else {
        slideshow.photoDuration = null;
    }

    var displayTime = document.getElementById("display-time");
    if (displayTime != null) {
        displayTime.value = time;
    }

    // show or hide the play button
    if (time < 1) {
        controls.setShowPlayButton(false);
    }
    else {
        controls.setShowPlayButton(true);
    }
}

//
// Function: setSelectedDisplayTime()
// Called when a new slide duration is selected
//
function setSelectedDisplayTime()
{
    var displayTime = document.getElementById("display-time");
    var time = parseFloat(displayTime.value);

	widget.setPreferenceForKey(displayTime.selectedIndex, createInstancePreferenceKey("selectedDisplayTime"));
	
    // 0 = never
    if (time == 0.0) {
        time = 0;
    }

    setDisplayTime(time);
}

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();

    photos = new Array();

    slideshow = new Slideshow(document.getElementById("photobox"), photos, photoChanged);
    infobutton = document.getElementById("info");

    controls = CreatePlayPauseControls("controls", "front", clickBack, clickPlay, clickPause, clickNext);
    caption = CreateCaptionControl("caption", "front", (attributes.showTitle == 0));
    hideInterfaceElements();

    populateDisplayTimeList(slideshow.getDisplayTimeValues());
    setDisplayTime(250);
    
	var obj = document.getElementById("cities");
	var pref = widget.preferenceForKey(createInstancePreferenceKey("selectedCities"));
	if (pref != null)
		obj.children[0].checked = pref;
		
	var obj = document.getElementById("more_cities");
	var pref = widget.preferenceForKey(createInstancePreferenceKey("selectedMoreCities"));
	if (pref != null)
		obj.children[0].checked = pref;
		
	var obj = document.getElementById("roads");
	var pref = widget.preferenceForKey(createInstancePreferenceKey("selectedRoads"));
	if (pref != null)
		obj.children[0].checked = pref;
		
	var obj = document.getElementById("road_numbers");
	var pref = widget.preferenceForKey(createInstancePreferenceKey("selectedRoadNumbers"));
	if (pref != null)
		obj.children[0].checked = pref;

	var obj = document.getElementById("rivers");
	var pref = widget.preferenceForKey(createInstancePreferenceKey("selectedRivers"));
	if (pref != null)
		obj.children[0].checked = pref;

	var obj = document.getElementById("radar_circles");
	var pref = widget.preferenceForKey(createInstancePreferenceKey("selectedRadarCircles"));
	if (pref != null)
		obj.children[0].checked = pref;
			
	var obj = document.getElementById("satellites");
	var pref = widget.preferenceForKey(createInstancePreferenceKey("selectedSatellite"));
	if (pref != null)
		obj.selectedIndex = pref;
	
	var str = obj.options[obj.selectedIndex].value;
	setTimeout(function () { loadPhotosFromFeed(str); }, 1000);

	obj = document.getElementById("numimages");
	pref = widget.preferenceForKey(createInstancePreferenceKey("selectedNumImages"));
	if(pref != null)
		obj.selectedIndex = pref;
		
	if(obj.options[obj.selectedIndex] == 'All')
		maxImages = 9999;
	else
		maxImages = parseInt(obj.options[obj.selectedIndex].value);

	obj = document.getElementById("display-time");
	pref = widget.preferenceForKey(createInstancePreferenceKey("selectedDisplayTime"));
	if(pref == null)
		pref = 4;
	obj.selectedIndex = pref;
	
	setDisplayTime(parseInt(obj.options[obj.selectedIndex].value));
	
	obj = document.getElementById("scale");
	pref = widget.preferenceForKey(createInstancePreferenceKey("selectedScale"));
	if(pref == null)
		pref = 2;
	obj.selectedIndex = pref;
	
	getVersion();

    document.addEventListener("keypress", keyPressed, true);
}

//
// Function: keyPressed(event)
// Handler for keyboard control of the slideshow
//
// event: onClick event from widget.
//
function keyPressed(event)
{
    switch (event.keyIdentifier) {
        case "U+000020":
            controls.keyClickPlay(event);
            break;
        case "Left":
            controls.keyClickBack(event);
            break;
        case "Right":
            controls.keyClickNext(event);
            break;
        default:
            return;
    }

    event.stopPropagation();
    event.preventDefault();
}

//
// Function: clickBack()
// Called by the back button to show the previous slide
//
function clickBack()
{
    slideshow.goBack();
}

//
// Function: clickNext()
// Called by the next button to show the next slide
//
function clickNext()
{
    slideshow.advance();
}

//
// Function: clickPause()
// Called by the pause button to pause the slideshow
//
function clickPause()
{
    if (finishedLoading) {
        slideshow.pause();
    }
}

//
// Function: clickPlay()
// Called by the play button to start the slideshow
//
function clickPlay()
{
    if (finishedLoading) {
        slideshow.resume();
    }
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
	slideshow.pause();
	
	// 20130502 Added by Michael B. Pawluk
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedDisplayTime"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedCities"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedMoreCities"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedRoads"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedRoadNumbers"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedRivers"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedRadarCircles"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedSatellite"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedNumImages"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedDisplayTime"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("selectedScale"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("lastChecked"));
	// 20130502 End Added by Michael B. Pawluk
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Pause the slideshow to prevent CPU usage
    slideshow.pause();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Resume the slideshow
	var sat = document.getElementById("satellites");
	var url = sat.options[sat.selectedIndex].value
	
	hideInterfaceElements();
	showLoadingMessage();
	
	willReload = 1;
	if(firstLoad) {
		firstLoad = 0;
	} else {
		setTimeout(function () { loadPhotosFromFeed(url); }, 1000);
	}
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    slideshow.pause();
	isBack = 1;
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display="none";
    back.style.display="block";
	
	window.resizeTo(469, 420);

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	getVersion();
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	
	isBack = 0;
	
	if(!willReload) {
		slideshow.resume();
		setTimeout(setSize, 250);
	}
	
    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    loadOverlays();
}

function changeSatellite(event)
{
	var sat = document.getElementById("satellites");
	var url = sat.options[sat.selectedIndex].value
	widget.setPreferenceForKey(sat.selectedIndex, createInstancePreferenceKey("selectedSatellite"));
	
	hideInterfaceElements();
	showLoadingMessage();
	
	willReload = 1;
	
    setTimeout(function () { loadPhotosFromFeed(url); }, 1);
}

// 20130502 Added by Michael B. Pawluk
function changeCities(event)
{
	var rdns = document.getElementById("cities");
	widget.setPreferenceForKey(rdns.children[0].checked, createInstancePreferenceKey("selectedCities"));	
}

function changeMoreCities(event)
{
	var rdns = document.getElementById("more_cities");
	widget.setPreferenceForKey(rdns.children[0].checked, createInstancePreferenceKey("selectedMoreCities"));	
}

function changeRoads(event)
{
	var rdns = document.getElementById("roads");
	widget.setPreferenceForKey(rdns.children[0].checked, createInstancePreferenceKey("selectedRoads"));	
}

function changeRoadNumbers(event)
{
	var rdns = document.getElementById("road_numbers");
	widget.setPreferenceForKey(rdns.children[0].checked, createInstancePreferenceKey("selectedRoadNumbers"));
}

function changeRivers(event)
{
	var rdns = document.getElementById("rivers");
	widget.setPreferenceForKey(rdns.children[0].checked, createInstancePreferenceKey("selectedRivers"));	
}

function changeRadarCircles(event)
{
	var rdns = document.getElementById("radar_circles");
	widget.setPreferenceForKey(rdns.children[0].checked, createInstancePreferenceKey("selectedRadarCircles"));	
}
// 20130502 End Added by Michael B. Pawluk

function setNumimages(event)
{
	var ni = document.getElementById("numimages");
	var sat = document.getElementById("satellites");
	var url = sat.options[sat.selectedIndex].value;
	widget.setPreferenceForKey(ni.selectedIndex, createInstancePreferenceKey("selectedNumImages"));
	
	if(ni.options[ni.selectedIndex].value == 'All')
		maxImages = 9999;
	else
		maxImages = parseInt(ni.options[ni.selectedIndex].value);
	
	hideInterfaceElements();
	showLoadingMessage();
	
	willReload = 1;

    setTimeout(function () { loadPhotosFromFeed(url); }, 1);
}

function setScale(event)
{
	var ni = document.getElementById("scale");
	widget.setPreferenceForKey(ni.selectedIndex, createInstancePreferenceKey("selectedScale"));
}

function visitCopyrightPage(event)
{
	var websiteURL = "http://www.ec.gc.ca/default.asp?lang=En&xml=5830C36B-1773-4E3E-AF8C-B21F54633E0A";
	widget.openURL(websiteURL);
}

function emailAuthor(event)
{
	var websiteURL = "mailto:mirtchovski@gmail.com?subject=EC%20Satellite%20Widget";
	// Show website code
	widget.openURL(websiteURL);
}


function emailMouseOver(event)
{
	var text = document.getElementById("email");
	text.style.textDecoration = 'underline';
}

function emailMouseOut(event)
{
	var text = document.getElementById("email");
	text.style.textDecoration = 'none';
}

function visitWO(event)
{
	var lang;
	var websiteURL = "http://www.weatheroffice.gc.ca";
	
	// Show website code
	widget.openURL(websiteURL);
}

function linkMouseOver(event)
{
	var text = document.getElementById("linkWO");
	text.style.textDecoration = 'underline';
}

function linkMouseOut(event)
{
	var text = document.getElementById("linkWO");
	text.style.textDecoration = 'none';
}

function visitVers(event)
{
	var websiteURL = "http://www.mirtchovski.com/code/environment.html";
	widget.openURL(websiteURL);
}

function versionMouseOut(event)
{
	var text = document.getElementById("newVersion");
	text.style.textDecoration = 'none';
}

function versiouMouseOver(event)
{
	var text = document.getElementById("newVersion");
	text.style.textDecoration = 'underline';
}

// Initialize the Dashboard event handlers
if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function captionClick(event)
{
    infobutton.click();
}
